Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/user_contributed/readme
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/user_contributed/readme	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/user_contributed/readme	(revision 2696)
@@ -0,0 +1,3 @@
+Integrators in this directory have been contributed by KPP users. By
+default, KPP will not search for integrators in this directory. To
+activate them, move them into the int/ directory.
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/user_contributed/ros2_manual.def
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/user_contributed/ros2_manual.def	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/user_contributed/ros2_manual.def	(revision 2696)
@@ -0,0 +1,5 @@
+#FUNCTION AGGREGATE
+#JACOBIAN SPARSE_LU_ROW 
+
+#DOUBLE ON
+#INTFILE ros2_manual
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/user_contributed/ros2_manual.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/user_contributed/ros2_manual.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/user_contributed/ros2_manual.f90	(revision 2696)
@@ -0,0 +1,119 @@
+! Rosenbrock integrator with manual time step control
+! Solve: d/dt c = f(t,c)
+
+! written by Edwin Spee, CWI, Amsterdam. Last update: July 28, 1997
+! email: Edwin.Spee@cwi.nl (http://edwin-spee.mypage.org/)
+! adapted to KPP-2.1 by Rolf Sander, Max-Planck Institute, Mainz, Germany, 2005
+!
+! Integration method for Ros2:
+! C_{n+1} = C_n + 3/2 dt k_1 + 1/2 dt k_2
+! k_1 = S f(t_n, C_n)
+! k_2 = S [f(t_{n+1},C_n + dt k_1) - 2 k_1]
+!
+! where g = 1.0 + sqrt(0.5_dp),
+! S = (I - g dt J ) ^ {-1}
+! with J the Jacobian
+
+MODULE KPP_ROOT_Integrator
+
+  USE KPP_ROOT_Precision, ONLY: dp
+
+  IMPLICIT NONE
+  PUBLIC
+  SAVE
+
+  ! description of the error numbers IERR
+  CHARACTER(LEN=50), PARAMETER, DIMENSION(1) :: IERR_NAMES = (/ &
+    'dummy value                                       ' /)
+
+CONTAINS
+
+  ! **************************************************************************
+
+  SUBROUTINE INTEGRATE( TIN, TOUT, &
+    ICNTRL_U, RCNTRL_U, ISTATUS_U, RSTATUS_U, IERR_U )
+
+    IMPLICIT NONE
+
+    KPP_REAL, INTENT(IN) :: TIN  ! TIN - Start Time
+    KPP_REAL, INTENT(IN) :: TOUT ! TOUT - End Time
+    ! Optional input parameters and statistics
+    INTEGER,  INTENT(IN),  OPTIONAL :: ICNTRL_U(20)
+    KPP_REAL, INTENT(IN),  OPTIONAL :: RCNTRL_U(20)
+    INTEGER,  INTENT(OUT), OPTIONAL :: ISTATUS_U(20)
+    KPP_REAL, INTENT(OUT), OPTIONAL :: RSTATUS_U(20)
+    INTEGER,  INTENT(OUT), OPTIONAL :: IERR_U
+
+    CALL ROS2(TIN, TOUT)
+
+    ! if optional parameters are given for output
+    ! use them to store information in them
+    IF (PRESENT(ISTATUS_U)) ISTATUS_U(:) = 0
+    IF (PRESENT(RSTATUS_U)) THEN
+      RSTATUS_U(:) = 0._dp
+      RSTATUS_U(1)=TOUT ! put final time into RSTATUS_U
+    ENDIF
+    IF (PRESENT(IERR_U)) IERR_U = 1 ! dummy value
+
+  END SUBROUTINE INTEGRATE
+
+  ! **************************************************************************
+
+  SUBROUTINE ROS2(Tstart,Tend)
+
+    USE KPP_ROOT_Jacobian,         ONLY: Jac_SP
+    USE KPP_ROOT_Global,           ONLY: VAR,   & ! VARiable species
+                                         FIX,   & ! FIXed species
+                                         RCONST   ! rate coefficients
+    USE KPP_ROOT_JacobianSP,       ONLY: LU_DIAG
+    USE KPP_ROOT_Function,         ONLY: Fun
+    USE KPP_ROOT_LinearAlgebra,    ONLY: KppDecomp, KppSolve
+    USE KPP_ROOT_Parameters,       ONLY: NVAR, LU_NONZERO
+
+    IMPLICIT NONE
+
+    KPP_REAL, INTENT(IN) :: Tstart, Tend
+
+    KPP_REAL :: dt ! time step                                          
+    KPP_REAL :: k1(NVAR), k2(NVAR), w1(NVAR), g, jvs(LU_NONZERO)
+    INTEGER ising, i
+
+    dt = Tend - Tstart
+    g = 1.0 + SQRT(0.5_dp)
+    CALL JAC_sp(VAR, FIX, RCONST, jvs)
+    jvs(1:LU_NONZERO) = -g*dt*jvs(1:LU_NONZERO)
+
+    ! Rolf von Kuhlmann:
+    ! optionally cut this out and replace it by directly addressed statements
+    DO i=1,NVAR
+      jvs(LU_DIAG(i)) = jvs(LU_DIAG(i)) + 1.0_dp
+    END DO
+
+    CALL KppDecomp (jvs, ising)
+
+    IF (ising /= 0) THEN
+      PRINT *,'ising <> 0, dt=',dt
+      STOP
+    END IF
+
+    CALL Fun(VAR, FIX, RCONST, k1 )
+
+    CALL KppSolve (jvs,k1)
+
+    DO i = 1,NVAR
+      w1(i) = MAX(0.0_dp, VAR(i) + dt * k1(i) )
+    END DO
+
+    CALL Fun(w1, FIX, RCONST, k2 )
+
+    k2(1:NVAR) = k2(1:NVAR) - 2.0_dp*k1(1:NVAR)
+    CALL KppSolve (jvs,k2)
+    DO i = 1,NVAR
+      VAR(i) = MAX( 0.0_dp, VAR(i)+1.5_dp*dt*k1(i)+0.5_dp*dt*k2(i) )
+    END DO
+
+  END SUBROUTINE ROS2
+
+  ! **************************************************************************
+
+END MODULE KPP_ROOT_Integrator
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/atoms
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/atoms	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/atoms	(revision 2696)
@@ -0,0 +1,107 @@
+#ATOMS
+        H	{  1 	Hydrogen	}; 
+	He	{  2	Helium  	};
+	Li	{  3    Litium		};
+	Be	{  4   		};
+	B	{  5   		};
+	C	{  6   		};
+	N	{  7   		};
+	O	{  8   		};
+	F	{  9   		};
+	Ne	{ 10   		};
+	Na	{ 11   		};
+	Mg	{ 12   		};
+	Al	{ 13   		};
+	Si	{ 14   		};
+	P	{ 15   		};
+	S	{ 16   		};
+	Cl	{ 17   		};
+	Ar	{ 18   		};
+	K	{ 19   		};
+	Ca	{ 20   		};
+	Sc	{ 21   		};
+	Ti	{ 22   		};
+	V	{ 23   		};
+	Cr	{ 24   		};
+	Mn	{ 25   		};
+	Fe	{ 26   		};
+	Co	{ 27   		};
+	Ni	{ 28   		};
+	Cu	{ 29   		};
+	Zn	{ 30   		};
+	Ga	{ 31   		};
+	Ge	{ 32   		};
+	As	{ 33   		};
+	Se	{ 34   		};
+	Br	{ 35   		};
+	Kr	{ 36   		};
+	Rb	{ 37   		};
+	Sr	{ 38   		};
+	Y	{ 39   		};
+	Zr	{ 40   		};
+	Nb	{ 41   		};
+	Mu	{ 42   		};
+	Tc	{ 43   		};
+	Ru	{ 44   		};
+	Rh	{ 45   		};
+	Pd	{ 46   		};
+	Ag	{ 47   		};
+	Cd	{ 48   		};
+	In	{ 49   		};
+	Sn	{ 50   		};
+	Sb	{ 51   		};
+	Te	{ 52   		};
+	I	{ 53   		};
+	Xe	{ 54   		};
+	Cs	{ 55   		};
+	Ba	{ 56   		};
+	La	{ 57   		};
+	Ce	{ 58   		};
+	Pr	{ 59   		};
+	Nd	{ 60   		};
+	Pm	{ 61   		};
+	Sm	{ 62   		};
+	Eu	{ 63   		};
+	Gd	{ 64   		};
+	Tb	{ 65   		};
+	Dy	{ 66   		};
+	Ho	{ 67   		};
+	Er	{ 68   		};
+	Tm	{ 69   		};
+	Yb	{ 70   		};
+	Lu	{ 71   		};
+	Hf	{ 72   		};
+	Ta	{ 73   		};
+	W	{ 74   		};
+	Re	{ 75   		};
+	Os	{ 76   		};
+	Ir	{ 77   		};
+	Pt	{ 78   		};
+	Au	{ 79   		};
+	Hg	{ 80   		};
+	Tl	{ 81   		};
+	Pb	{ 82   		};
+	Bi	{ 83   		};
+	Po	{ 84   		};
+	At	{ 85   		};
+	Rn	{ 86   		};
+	Fr	{ 87   		};
+	Ra	{ 88   		};
+	Ac	{ 89   		};
+	Th	{ 90   		};
+	Pa	{ 91   		};
+	U	{ 92   		};
+	Np	{ 93   		};
+	Pu	{ 94   		};
+	Am	{ 95   		};
+	Cm	{ 96   		};
+	Bk	{ 97   		};
+	Cf	{ 98   		};
+	Es	{ 99   		};
+	Fm	{100   		};
+	Md	{101   		};
+	No	{102   		};
+	Lr	{103   		};
+	Unq	{104   		};
+	Unp	{105   		};
+	Unh	{106   		};
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cbm4.def
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cbm4.def	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cbm4.def	(revision 2696)
@@ -0,0 +1,63 @@
+#include atoms
+#include ./cbm4.spc
+#include ./cbm4.eqn
+
+{#LANGUAGE Fortran77
+#INTEGRATOR rodas3
+#DRIVER general}
+
+#LOOKATALL
+
+#MONITOR O3;
+
+#INITVALUES
+  CFACTOR = 2.55E+10; {ppb-to-mcm}
+  ALL_SPEC = 1.0E-8;
+{Variable species}
+  NO   = 50.0;
+  NO2  = 20.0;
+  HONO = 1.0;
+  O3   = 100.0;
+  HCHO = 10.0;
+  ALD2 = 10;
+  PAN  = 1.0;
+  PAR  = 50.0;
+  OLE  = 10.0;
+  ETH  = 10.0;
+  TOL  = 10.0;
+  XYL  = 10.0;
+  ISOP = 10.0;
+  CO   = 300.0;
+{Fixed species}
+  H2O  = 1.25E+8; {30 %}
+
+
+#INLINE F77_INIT
+        TSTART = 12.D0*3600.D0
+        TEND = TSTART + 24.D0*3600.D0 * 5
+        DT = 3600.D0
+        TEMP = 288.15
+#ENDINLINE
+
+#INLINE F90_INIT
+        TSTART = 12.D0*3600.D0
+        TEND = TSTART + 24.D0*3600.D0 * 5
+        DT = 3600.D0
+        TEMP = 288.15
+#ENDINLINE
+
+#INLINE MATLAB_INIT
+   TSTART = 12.0*3600.0;
+   TEND = TSTART + 24.0*3600.0*5;
+   DT = 3600.0;
+   TEMP = 288.15;
+#ENDINLINE
+
+#INLINE C_INIT
+   TSTART = 12.0*3600.0;
+   TEND = TSTART + 24.0*3600.0*5;
+   DT = 3600.0;
+   TEMP = 288.15;
+#ENDINLINE
+
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cbm4.eqn
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cbm4.eqn	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cbm4.eqn	(revision 2696)
@@ -0,0 +1,119 @@
+#EQUATIONS {of the CBM-IV mechanism}
+
+{ 1.} NO2 + hv =  NO + O              :  8.89E-3*SUN ;
+{ 2.} O {+ O2 + M} = O3               :  ARR2(1.4E+3, 1175.0) ;
+{ 3.} O3 + NO = NO2                   :  ARR2(1.8E-12, -1370.0) ;
+{ 4.} O + NO2 = NO                    :  9.3E-12 ;
+{ 5.} O + NO2   = NO3                 :  ARR2(1.6E-13, 687.0) ;
+{ 6.} O + NO   =  NO2                 :  ARR2(2.2E-13, 602.0) ;
+{ 7.} O3 + NO2 =  NO3                 :  ARR2(1.2E-13, -2450.0) ;
+{ 8.} O3 + hv = O                     :  3.556E-04*SUN ; {4.0E-2*RCONST(1) ;}
+{ 9.} O3 + hv = O1D                   :  2.489E-05*SUN ; {2.8E-3*RCONST(1) ;}
+{10.} O1D   = O                       :  ARR2(1.9E+8, 390.0)  ;
+
+{11.} O1D + H2O = 2OH                 :  2.2E-10 ;
+{12.} O3 + OH = HO2                   :  ARR2(1.6E-12, -940.0) ;
+{13.} O3 + HO2 = OH                   :  ARR2(1.4E-14, -580.0) ;
+{14.} NO3 + hv = 0.89 NO2 + 0.89 O 
+                 + 0.11 NO            :  1.378E-01*SUN ; {15.5*RCONST(1);}
+{15.} NO3 + NO = 2 NO2                :  ARR2(1.3E-11, 250.0) ;
+{16.} NO3 + NO2 = NO + NO2            :  ARR2(2.5E-14, -1230.0) ;
+{17.} NO3 + NO2   =  N2O5             :  ARR2(5.3E-13, 256.0) ;
+{18.} N2O5 + H2O = 2 HNO3             :  1.3E-21 ;
+{19.} N2O5   =  NO3 + NO2             :  ARR2(3.5E+14, -10897.0) ;
+{20.} 2 NO  =  2 NO2                  :  ARR2(1.8E-20, 530.0) ;
+
+
+{21.} NO + NO2 + H2O = 2 HONO         :  4.4E-40 ;
+{22.} OH + NO   =  HONO               :  ARR2(4.5E-13, 806.0) ;
+{23.} HONO + hv =  OH + NO            :  1.511e-03*SUN ; {0.17*RCONST(1);}
+{24.} OH + HONO =  NO2                :  6.6E-12 ;
+{25.} 2 HONO = NO + NO2               :  1.0E-20 ;
+{26.} OH + NO2   =  HNO3              :  ARR2(1.0E-12, 713.0) ;
+{27.} OH + HNO3   =  NO3              :  ARR2(5.1E-15, 1000.0) ;
+{28.} HO2 + NO = OH + NO2             :  ARR2(3.7E-12, 240.0) ;
+{29.} HO2 + NO2   =  PNA              :  ARR2(1.2E-13, 749.0) ;
+{30.} PNA   = HO2 + NO2               :  ARR2(4.8E+13, -10121.0) ;
+
+{31.} OH + PNA = NO2                  :  ARR2(1.3E-12, 380.0) ;
+{32.} 2 HO2 = H2O2                    :  ARR2(5.9E-14, 1150.0)  ;
+{33.} 2 HO2 + H2O = H2O2              :  ARR2(2.2E-38, 5800.0) ;
+{34.} H2O2 + hv = 2 OH                :  6.312E-06*SUN ; {7.1E-4*RCONST(1);}
+{35.} OH + H2O2 = HO2                 :  ARR2(3.1E-12, -187.0) ;
+{36.} OH + CO  = HO2                  :  2.2E-13 ;
+{37.} HCHO + OH  =  HO2 + CO          :  1.0E-11 ;
+{38.} HCHO + hv {+ 2 O2} = 2 HO2 + CO :  2.845E-05*SUN ; {3.2E-3*RCONST(1);}
+{39.} HCHO +  hv = CO                 :  3.734E-05*SUN ; {4.2E-3*RCONST(1);}
+{40.} HCHO + O = OH + HO2 + CO        :  ARR2(3.0E-11, -1550.0) ;
+
+{41.} HCHO + NO3  = HNO3 
+                        + HO2 + CO    :  6.3E-16 ;
+{42.} ALD2 + O  =  C2O3 + OH          :  ARR2(1.2E-11, -986.0) ;
+{43.} ALD2 + OH = C2O3                :  ARR2(7.0E-12, 250.0) ;
+{44.} ALD2 + NO3  = C2O3 + HNO3       :  2.5E-15  ;
+{45.} ALD2 + hv {+ 2 O2} = HCHO + XO2 
+                         + CO + 2 HO2 :  4.00E-06*SUN ; {4.5E-4*RCONST(1);}
+{46.} C2O3 + NO  = HCHO + XO2 
+                       + HO2 + NO2    :  ARR2(5.4E-12, 250.0) ;
+{47.} C2O3 + NO2 = PAN                :  ARR2(8.0E-20, 5500.0) ;
+{48.} PAN = C2O3 + NO2                :  ARR2(9.4E+16, -14000.0) ;
+{49.} 2 C2O3 = 2 HCHO + 2 XO2 + 2 HO2 :  2.0E-12  ;
+{50.} C2O3 + HO2 = 0.79 HCHO 
+   + 0.79 XO2 + 0.79 HO2 + 0.79 OH    :  6.5E-12 ;
+
+{51.} OH = HCHO + XO2 + HO2           :  ARR2(1.1E+2, -1710.0) ;
+{52.} PAR + OH = 0.87 XO2 + 0.13 XO2N 
+               + 0.11 HO2 + 0.11 ALD2
+               + 0.76 ROR - 0.11 PAR  :  8.1E-13 ;
+{53.} ROR = 1.1 ALD2 + 0.96 XO2 
+               + 0.94 HO2 + 0.04 XO2N
+               + 0.02 ROR - 2.10 PAR  :  ARR2(1.0E+15, -8000.0) ;
+{54.} ROR = HO2                       :  1.6E+03 ;
+{55.} ROR + NO2 =  PROD               :  1.5E-11  ;
+{56.} O + OLE = 0.63 ALD2 + 0.38 HO2 
+                + 0.28 XO2 + 0.3 CO
+                + 0.2 HCHO + 0.02 XO2N 
+                + 0.22 PAR + 0.2 OH   :  ARR2(1.2E-11, -324.0) ;
+{57.} OH + OLE = HCHO + ALD2 + XO2 
+                 + HO2 - PAR          :  ARR2(5.2E-12, 504.0) ;
+{58.} O3 + OLE = 0.5 ALD2 + 0.74 HCHO 
+                 + 0.33 CO + 0.44 HO2 
+                 + 0.22 XO2
+                 + 0.1 OH - PAR       :  ARR2(1.4E-14, -2105.0)  ;
+{59.} NO3 + OLE = 0.91 XO2 + HCHO 
+                  + ALD2 + 0.09 XO2N                          
+                  + NO2 - PAR         :  7.7E-15 ;
+{60.} O + ETH = HCHO + 0.7 XO2 + CO
+                + 1.7 HO2 + 0.3 OH    :  ARR2(1.0E-11, -792.0) ;
+
+{61.} OH + ETH = XO2 + 1.56 HCHO + HO2 + 0.22 ALD2        :  ARR2(2.0E-12, 411.0)  ;
+{62.} O3 + ETH = HCHO + 0.42 CO + 0.12 HO2                :  ARR2(1.3E-14, -2633.0) ;
+{63.} OH + TOL = 0.08 XO2 + 0.36 CRES 
+                 + 0.44 HO2 + 0.56 TO2                    :  ARR2(2.1E-12, 322.0) ;
+{64.} TO2 + NO =  0.9 NO2 + 0.9 OPEN + 0.9 HO2            :  8.1E-12 ;
+{65.} TO2 = HO2 + CRES                                    :  4.20 ;
+{66.} OH + CRES = 0.4 CRO + 0.6 XO2 + 0.6 HO2 + 0.3 OPEN  :  4.1E-11  ;
+{67.} NO3 + CRES = CRO + HNO3                             :  2.2E-11 ;
+{68.} CRO + NO2 = PROD                                    :  1.4E-11 ;
+{69.} OH + XYL = 0.7 HO2 + 0.5 XO2 + 0.2 CRES + 0.8 MGLY
+                 + 1.10 PAR + 0.3 TO2                     :  ARR2(1.7E-11, 116.0) ;
+{70.} OH + OPEN = XO2 + C2O3 + 2 HO2 + 2 CO + HCHO        :  3.0E-11 ;
+
+{71.} OPEN + hv = C2O3 + CO + HO2                         :  5.334E-05*SUN ; {6.0E-3*RCONST(1);}
+{72.} O3 + OPEN = 0.03 ALD2 + 0.62 C2O3 
+                  + 0.7 HCHO + 0.03 XO2 + 0.69 CO 
+                  + 0.08 OH + 0.76 HO2 + 0.2 MGLY         :  ARR2(5.4E-17, -500.0)  ;
+{73.} OH + MGLY =  XO2 + C2O3                             :  1.70E-11 ;
+{74.} MGLY + hv = C2O3 + CO + HO2                         :  1.654E-04*SUN ; {1.86E-2*RCONST(1);}
+{75.} O + ISOP =  0.6 HO2 + 0.8 ALD2 + 0.55 OLE + 0.5 XO2
+                  + 0.5 CO + 0.45 ETH + 0.9 PAR           :  1.80E-11  ;
+{76.} OH + ISOP = HCHO + XO2 + 0.67 HO2 
+                  + 0.4 MGLY + 0.2 C2O3
+                  + ETH + 0.2 ALD2 + 0.13 XO2N            :  9.6E-11  ;
+{77.} O3 + ISOP = HCHO + 0.4 ALD2 + 0.55 ETH + 0.2 MGLY 
+                  + 0.06 CO + 0.1 PAR + 0.44 HO2 + 0.1 OH :  1.2E-17 ;
+{78.} NO3 + ISOP =  XO2N                                  :  3.2E-13 ;
+{79.} XO2 + NO = NO2                                      :  8.1E-12 ;
+{80.} 2 XO2 =  PROD                                       :  ARR2(1.7E-14, 1300.0) ;
+{81.} XO2N + NO =  PROD                                   :  6.8E-13 ;
+ 
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cbm4.spc
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cbm4.spc	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cbm4.spc	(revision 2696)
@@ -0,0 +1,41 @@
+#DEFVAR
+    NO          = N + O ;       {nitric oxide}
+    NO2         = N + 2O ;      {nitrogen dioxide}
+    NO3         = N + 3O ;      {nitrogen trioxide}
+    N2O5        = 2N + 5O ;     {dinitrogen pentoxide}
+    HONO        = H + 2O + N ;  {nitrous acid}
+    HNO3        = H + N + 3O ;  { nitric acid }
+    PNA         = H + 4 O + N ; {HO2NO2 peroxynitric acid}
+    O1D         = O ;           {oxygen atomic first singlet state}
+    O           = O ;           {oxygen atomic ground state (3P)}
+    OH          = O + H ;       {hydroxyl radical}
+    O3          = 3O ;          {ozone}
+    HO2         = H + 2O ;      {perhydroxyl radical}
+    H2O2        = 2H + 2O ;     {hydrogen peroxide}
+    HCHO        = C + 2H + O ;  {formalydehyde}
+    ALD2        = IGNORE ;      {high molecular weight aldehides}
+    C2O3        = 2C + 3H + 3O ; {CH3CO(O)OO peroxyacyl radical}
+    PAN         = 2C + 3H + 5O + N ; {CH3C(O)OONO2, peroxyacyl nitrate}
+    PAR         = IGNORE ;      {parafin carbon bond}
+    ROR         = IGNORE ;      {secondary organic oxy radical}
+    OLE         = IGNORE ;      {olefinic carbon bond}
+    ETH         = 2C + 4H ;     {CH2=CH2 ethene}
+    TOL         = 7C + 8H ;     {C6H5-CH3 toluene}
+    CRES        = IGNORE ;      {cresol and h.m.w. phenols}
+    TO2         = IGNORE ;      {toluene-hydroxyl radical adduct}
+    CRO         = IGNORE ;      {methylphenoxy radical}
+    OPEN        = IGNORE ;      {h.m.w. aromatic oxidation ring fragment}
+    XYL         = 8C + 10H ;    {C6H4-(CH3)2 xylene}
+    MGLY        = 3C + 4H + 2O ; {CH3C(O)C(O)H methylglyoxal}
+    ISOP        = IGNORE ;      {isoprene}
+    XO2         = IGNORE ;      {NO-to-NO2 operation}
+    XO2N        = IGNORE ;      {NO-to-nitrate operation}          
+    CO          = C + O ;       {carbon monoxide}
+
+#DEFFIX
+    H2O         = H + 2O ;      {water}
+    H2          = 2H ;          {molecular hydrogen}
+    O2          = 2O ;          {molecular oxygen}
+    N2          = 2N ;          {molecular nitrogen}
+    CH4         = C + 4H ;      {methane}
+    M           = IGNORE ;      {third body}
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cell_cycle.def
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cell_cycle.def	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cell_cycle.def	(revision 2696)
@@ -0,0 +1,139 @@
+{Model of hysteresis and irreversible transition in eukaryotic cell}
+
+#DEFVAR
+A  = ignore; {protein that activates Cdh1 at finish}
+AYp= ignore; {complex}
+Yp = ignore; {inactive (phosphorylated) Cdh1-P/APC}
+XY = ignore; {complex}
+Y  = ignore; {active Cdh1/APC complex}
+X  = ignore; {cyclin/Cdk dimer}
+YX = ignore; {complex}
+XYX= ignore; {complex}
+G  = ignore; {complex}
+TF = ignore; {complex}
+TFp= ignore; {complex}
+C1 = ignore; {complex}
+C2 = ignore; {complex}
+mas= ignore; {mass of the cell} 
+
+
+#EQUATIONS
+mas    = 2mas    : (0.01);
+2mas    = mas    : (0.001);
+PROD    = X      : (0.02);   {k1}
+X      =  PROD   : (0.05);   {k2 prime}
+Y + X  =  YX     : (1000);   {k2f double prime}
+YX     =  Y + X  : (3);      {k2r double prime}
+YX     =  Y      : (1);      {k2  double prime}
+X + Y  =  XY     : (1200);   {k4f}
+XY     =  X + Y  : (35);     {k4r}
+XY     =  X + Yp : (80);     {k4}
+A + Yp =  AYp    : (4000);   {k3f}
+AYp    =  A + Yp : (75);     {k3r}
+AYp    =  A + Y  : (60);     {k3}
+X + YX =  XYX    : (360);    {k5f}
+XYX    =  X + YX : (18);     {k5r}
+XYX    =  2X + Yp: (16);     {k6}
+A      = PROD    : (0.4);    {k6 prime}
+AYp      = Yp    : (0.4);    {k6 prime}
+G       = G + A  : (0.00075);{k5 prime}
+TF + X  = X + TFp: (2.6);    {k7f}
+TFp     = TF     : (4.0);    {k7r}
+TFp + G = C1     : (1.2);    {k8f}
+C1      = TFp + G   : (320); {k8r}
+C1      =  C1 + A   : (0.15);{k9}
+TFp + C1= C2        : (65);  {k10f}
+C2      =  C1 + TFp : (0.2); {k10r}
+C2      = C2 + A    : (3);   {k11}
+
+#LOOKAT X;
+#MONITOR X;
+
+#INITVALUES
+CFACTOR = 1;
+mas=0.1046E+01; 
+TF=0.8979E+01; 
+XY=0.5458E-02; 
+XYX=0.8918E-02; 
+YX=0.2989E-02; 
+X=0.1275E+00; 
+Y=0.1714E-02; 
+Yp=0.9605E+00; 
+AYp=0.2046E-01; 
+A=0.8577E-03; 
+C2=0.1692E-02; 
+C1=0.1769E-04; 
+TFp=0.1731E-01; 
+G=0.9983E+00;
+
+#INLINE F77_INIT
+      TSTART = 0.d0
+      TEND   = 1000.d0
+      DT     = 5.d0
+      Volume = 1000.d0
+#ENDINLINE
+
+#INLINE F77_UTIL
+      DOUBLE PRECISION FUNCTION CellMass(t)
+       ! Cell mass evolution in time
+       DOUBLE PRECISION t
+       DOUBLE PRECISION m0, mstar, mu, one
+       PARAMETER (m0    = 1.0d0)
+       PARAMETER (mstar = 10.0d0)
+       PARAMETER (mu    = 0.01d0)
+       PARAMETER (one   = 1.0d0)
+       CellMass = mstar/(one-(one-mstar/m0)*EXP(-mu*t))
+      END
+#ENDINLINE
+
+#INLINE F90_INIT
+   TSTART = 0.d0
+   TEND   = 1000.d0
+   DT     = 5.d0
+   !Volume = 1000.d0
+#ENDINLINE
+
+#INLINE F90_UTIL
+   DOUBLE PRECISION FUNCTION CellMass(t)
+     ! Cell mass evolution in time
+     DOUBLE PRECISION, INTENT(IN) :: t
+     DOUBLE PRECISION, PARAMETER:: m0    = 1.0d0
+     DOUBLE PRECISION, PARAMETER:: mstar = 10.0d0
+     DOUBLE PRECISION, PARAMETER:: mu    = 0.01d0
+     DOUBLE PRECISION, PARAMETER:: one   = 1.0d0
+     CellMass = mstar/(one-(one-mstar/m0)*EXP(-mu*t))
+   END FUNCTION CellMass
+#ENDINLINE
+
+#INLINE MATLAB_INIT
+   global TSTART TEND DT TEMP
+   TSTART = 0;
+   TEND   = 1000;
+   DT     = 5.0;
+   Volume = 1000.0;
+#ENDINLINE
+
+#INLINE MATLAB_UTIL
+   function m = CellMass(t)
+     % Cell mass evolution in time
+     m = 10/(1+9*exp(-0.01*t));
+   return
+#ENDINLINE
+
+#INLINE C_INIT
+   TSTART = 0.0;
+   TEND   = 1000.0;
+   DT     = 5.0;
+   Volume = 1000.0;
+#ENDINLINE
+
+#INLINE C_UTIL
+   double CellMass(double t)
+   {/* Cell mass evolution in time */
+     const double m0    = 1.0;
+     const double mstar = 10.0;
+     const double mu    = 0.01;
+     const double one   = 1.0;
+     return mstar/(one-(one-mstar/m0)*exp(-mu*t));
+   }
+#ENDINLINE
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cell_cycle_mRNA.def
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cell_cycle_mRNA.def	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/cell_cycle_mRNA.def	(revision 2696)
@@ -0,0 +1,144 @@
+{Model of hysteresis and irreversible transition in eukaryotic cell
+   WITH mRNA! }
+
+#DEFVAR
+A  = ignore; {protein that activates Cdh1 at finish}
+AYp= ignore; {complex}
+Yp = ignore; {inactive (phosphorylated) Cdh1-P/APC}
+XY = ignore; {complex}
+Y  = ignore; {active Cdh1/APC complex}
+X  = ignore; {cyclin/Cdk dimer}
+YX = ignore; {complex}
+XYX= ignore; {complex}
+G  = ignore; {complex}
+TF = ignore; {complex}
+TFp= ignore; {complex}
+C1 = ignore; {complex}
+C2 = ignore; {complex}
+R  = ignore; {mRNA}
+mas= ignore; {mass of the cell} 
+
+
+#EQUATIONS
+mas     =  2mas     : (0.01);
+2mas    =  mas      : (0.001);
+PROD    =  X        : (0.02);   {k1}
+X       =  PROD     : (0.05);   {k2 prime}
+Y + X   =  YX       : (1000);   {k2f double prime}
+YX      =  Y + X    : (3);      {k2r double prime}
+YX      =  Y        : (1);      {k2  double prime}
+X + Y   =  XY       : (1200);   {k4f}
+XY      =  X + Y    : (35);     {k4r}
+XY      =  X + Yp   : (80);     {k4}
+A + Yp  =  AYp      : (4000);   {k3f}
+AYp     =  A + Yp   : (75);     {k3r}
+AYp     =  A + Y    : (60);     {k3}
+X + YX  =  XYX      : (360);    {k5f}
+XYX     =  X + YX   : (18);     {k5r}
+G       =  G + R    : (0.00075);{k5 prime}
+XYX     =  2X + Yp  : (16);     {k6}
+A       =  PROD     : (0.4);    {k6 prime}
+AYp     =  Yp       : (0.4);    {k6 prime}
+TF + X  =  X + TFp  : (2.5);    {k7f}
+TFp     =  TF       : (4.0);    {k7r}
+TFp + G =  C1       : (1.2);    {k8f}
+C1      =  TFp + G  : (320);    {k8r}
+C1      =  C1 + R   : (0.15);   {k9}
+TFp + C1=  C2       : (65);     {k10f}
+C2      =  C1 + TFp : (0.2);    {k10r}
+C2      =  C2 + R   : (3);      {k11}
+R       =  PROD     : (1);      {krd}
+R       =  R + A    : (1);      {krs}
+
+#LOOKAT X;
+#MONITOR X;
+
+#INITVALUES
+CFACTOR = 1;
+mas = 0.1046E+01; 
+TF  = 0.8979E+01; 
+XY  = 0.5458E-02; 
+XYX = 0.8918E-02; 
+YX  = 0.2989E-02; 
+X   = 0.1275E+00; 
+Y   = 0.1714E-02; 
+Yp  = 0.9605E+00; 
+AYp = 0.2046E-01; 
+A   = 0.8577E-03; 
+C2  = 0.1692E-02; 
+C1  = 0.1769E-04; 
+TFp = 0.1731E-01; 
+G   = 0.9983E+00;
+R   = 0;
+
+#INLINE F77_INIT
+      TSTART = 0.d0
+      TEND   = 1000.d0
+      DT     = 5.d0
+      Volume = 1000.d0
+#ENDINLINE
+
+#INLINE F77_UTIL
+      DOUBLE PRECISION FUNCTION CellMass(t)
+       ! Cell mass evolution in time
+       DOUBLE PRECISION t
+       DOUBLE PRECISION m0, mstar, mu, one
+       PARAMETER (m0    = 1.0d0)
+       PARAMETER (mstar = 10.0d0)
+       PARAMETER (mu    = 0.01d0)
+       PARAMETER (one   = 1.0d0)
+       CellMass = mstar/(one-(one-mstar/m0)*EXP(-mu*t))
+      END
+#ENDINLINE
+
+#INLINE F90_INIT
+   TSTART = 0.d0
+   TEND   = 1000.d0
+   DT     = 5.d0
+   !Volume = 1000.d0
+#ENDINLINE
+
+#INLINE F90_UTIL
+   DOUBLE PRECISION FUNCTION CellMass(t)
+     ! Cell mass evolution in time
+     DOUBLE PRECISION, INTENT(IN) :: t
+     DOUBLE PRECISION, PARAMETER:: m0    = 1.0d0
+     DOUBLE PRECISION, PARAMETER:: mstar = 10.0d0
+     DOUBLE PRECISION, PARAMETER:: mu    = 0.01d0
+     DOUBLE PRECISION, PARAMETER:: one   = 1.0d0
+     CellMass = mstar/(one-(one-mstar/m0)*EXP(-mu*t))
+   END FUNCTION CellMass
+#ENDINLINE
+
+#INLINE MATLAB_INIT
+   global TSTART TEND DT TEMP
+   TSTART = 0;
+   TEND   = 1000;
+   DT     = 5.0;
+   Volume = 1000.0;
+#ENDINLINE
+
+#INLINE MATLAB_UTIL
+   function m = CellMass(t)
+     % Cell mass evolution in time
+     m = 10/(1+9*exp(-0.01*t));
+   return
+#ENDINLINE
+
+#INLINE C_INIT
+   TSTART = 0.0;
+   TEND   = 1000.0;
+   DT     = 5.0;
+   Volume = 1000.0;
+#ENDINLINE
+
+#INLINE C_UTIL
+   double CellMass(double t)
+   {/* Cell mass evolution in time */
+     const double m0    = 1.0;
+     const double mstar = 10.0;
+     const double mu    = 0.01;
+     const double one   = 1.0;
+     return mstar/(one-(one-mstar/m0)*exp(-mu*t));
+   }
+#ENDINLINE
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/chapman.def
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/chapman.def	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/chapman.def	(revision 2696)
@@ -0,0 +1,59 @@
+#include small_strato.spc
+#include small_strato.eqn
+ 
+
+//#LANGUAGE Fortran77          {Output Language}
+//#DOUBLE ON                   {Double Precision}
+//#JACOBIAN SPARSE_LU_ROW      {Use Sparse DATA STRUCTURES}
+ 
+//#INTEGRATOR rodas3
+//#DRIVER general
+
+
+#LOOKATALL                     {File Output}
+#MONITOR O3;N;O2;O;NO;O1D;NO2; {Screen Output}
+
+#CHECK O; N;                   {Check Mass Balance}
+ 
+#INITVALUES                    {Initial Values}
+ 
+CFACTOR = 1.    ;              {Conversion Factor} 
+O1D = 9.906E+01 ; 
+O   = 6.624E+08 ; 
+O3  = 5.326E+11 ; 
+O2  = 1.697E+16 ;
+NO  = 8.725E+08 ; 
+NO2 = 2.240E+08 ; 
+M   = 8.120E+16 ;
+ 
+#INLINE F77_INIT
+       	TSTART = (12*3600)
+        TEND = TSTART + (3*24*3600)
+        DT = 0.25*3600  
+        TEMP = 270
+#ENDINLINE         
+ 
+#INLINE F90_INIT
+        TSTART = (12*3600)
+        TEND = TSTART + (3*24*3600)
+        DT = 0.25*3600  
+        TEMP = 270
+#ENDINLINE         
+ 
+#INLINE MATLAB_INIT
+  global TSTART TEND DT TEMP
+  TSTART = (12*3600);
+  TEND = TSTART + (3*24*3600);
+  DT = 0.25*3600;  
+  TEMP = 270;
+#ENDINLINE         
+
+
+#INLINE C_INIT
+        TSTART = (12*3600);
+        TEND = TSTART + (3*24*3600);
+        DT = 0.25*3600;
+        TEMP = 270;
+#ENDINLINE
+
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/chapman.eqn
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/chapman.eqn	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/chapman.eqn	(revision 2696)
@@ -0,0 +1,13 @@
+#EQUATIONS { Chapman with catalytical loss }
+
+// Classical Chapman
+<R1>  O2   + hv = 2O		: (2.643E-10) * SUN*SUN*SUN;
+<R2>  O2   + O  = O3		: (8.018E-17);
+<R3>  O3   + hv = O   + O2 	: (6.120E-04) * SUN;
+<R4>  O3   + O  = 2O2		: (1.576E-15);
+// Catalytical loss reaction
+<R5>  NO   + O3 = NO2 + O2 	: (6.062E-15);
+<R6>  NO2  + O  = NO  + O2	: (1.069E-11);
+//<R7>  NO2  + hv = NO  + O       : (1.289E-02) * SUN;
+
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/chapman.spc
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/chapman.spc	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/models/chapman.spc	(revision 2696)
@@ -0,0 +1,15 @@
+#include atoms
+
+#DEFVAR
+O   = O;    	    { Atomic oxygen }	
+O3  = O + O + O;    { Ozone }
+NO  = N + O;	    { Nitric oxide }	     
+NO2 = N + O + O;    { Nitrogen dioxide }
+
+#DEFFIX
+M   = O + O + N + N;{ Atmospheric generic molecule }
+O2  = O + O;        { Molecular oxygen }
+
+
+
+
